<?php
/**
 * @package PEG
 * @author anatoo<anatoo@nequal.jp>
 * @license http://www.opensource.org/licenses/mit-license.php MIT License
 * @version $Id: Preg.php 655 2009-04-12 07:26:42Z anatoo $
 */

class PEG_Preg implements PEG_IParser 
{
    protected $pattern;
    function __construct($pattern)
    {
        $this->pattern = $pattern;
    }
    
    function parse(PEG_IContext $context)
    {
        if (preg_match($this->pattern, $context->get(), $matches, null, $context->tell())) {
            $context->seek($context->tell() + strlen($matches[0]));
            return $matches[0];
        }
        
        return PEG::failure();
    }
}